
func increment(num: Int) -> Int {
    return num+1
}

var x = 9
increment(num: x)

func greet(name: String) -> String {
    return "Hello, " + name + "!"
}

greet(name: "Pat")

func compare(num1: Int, num2: Int) {
    if (num1 == num2) {
        print("same")
    }
    else {
        print("different")
    }
}

compare(num1: 4, num2: 6)

func sum(from low: Int, to high : Int) -> Int {
    var total = 0;
    for i in low...high {
        total += i
    }
    return total
}

sum(from: 1, to: 100)

struct Name {
    private(set) var first: String
    private(set) var middle: Character
    private(set) var last: String

    func compare(with other: Name) -> Int {
        if self.last == other.last &&
             self.first == other.first &&
             self.middle == other.middle {
            return 0
        } else if self.last < other.last ||
                    (self.last == other.last &&
                      self.first < other.first) ||
                    (self.last == other.last &&
                      self.first == other.first &&
                      self.middle < other.middle) {
                    return -1
        }
        else {
            return 1
        }
    }
    
    mutating func changeLastName(to newName: String) {
        self.last = newName
    }
}

var me = Name(first: "David", middle: "W", last: "Reed")
var him = Name(first: "Mark", middle: "V", last: "Reedy")

me.compare(with: him)
me.compare(with: me)
him.compare(with: me)

me.last
me.changeLastName(to: "Pseudonym")
me.last

struct Die {
    private(set) var numSides: Int
    private(set) var numRolls: Int

    init(withSides sides: Int = 6) {
        self.numSides = sides
        self.numRolls = 0
    }
    
    mutating func roll() -> Int {
        self.numRolls += 1
        return Int.random(in: 1...numSides)
    }
}

var d1 = Die()
for _ in 1...10 {
    print(d1.roll())
}

print()

var d2 = Die(withSides: 8)
for _ in 1...10 {
    print(d2.roll())
}

struct RouletteWheel {
    private var die = Die(withSides: 36)
    var numSpins: Int {
        return die.numRolls
    }

    mutating func spin() -> String {
        let dieRoll = self.die.roll()
        if dieRoll == 36 {
            return "00"
        }
        else if dieRoll == 35 {
            return "0"
        }
        else {
            return String(dieRoll)
        }
    }
}

var wheel = RouletteWheel()
for _ in 1...10 {
    print(wheel.spin())
}
print(wheel.numSpins)

class DieClass {
    private var numRolls: Int
    private var numSides: Int

    init(withSides sides: Int = 6) {
        self.numSides = sides
        self.numRolls = 0
    }

    func roll() -> Int {
        self.numRolls += 1
        return Int.random(in: 1...self.numSides)
    }

    func numberOfRolls() -> Int {
        return self.numRolls
    }

    func numberOfSides() -> Int {
        return self.numSides
    }
}

var d = DieClass()
for _ in 1...10 {
    print(d.roll())
}

print(d.numberOfRolls())

class ColoredDie: DieClass {
    private var color: String

    init(withColor color: String,
             withSides sides: Int = 6) {
        self.color = color
        super.init(withSides: sides)
    }
    
    override func roll() -> Int {
        if self.color == "red" {
            return 1
        }
        else {
            return super.roll()
        }
    }

    func dieColor() -> String {
        return self.color
    }
}

var dc = ColoredDie(withColor: "white")
print(dc.roll())
print(dc.dieColor())

var poly: DieClass = ColoredDie(withColor: "red")
print(poly.roll())

